package com.logicbig.example;

import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.ClassPathScanningCandidateComponentProvider;
import org.springframework.core.convert.converter.ConverterFactory;
import org.springframework.core.type.filter.AssignableTypeFilter;

import java.util.Set;

public class SpringBuiltInConverterFactoriesFinder {
    public static void main(String[] args) {
        ClassPathScanningCandidateComponentProvider provider =
                new ClassPathScanningCandidateComponentProvider(false);
        provider.addIncludeFilter(new AssignableTypeFilter(ConverterFactory.class));
        Set<BeanDefinition> components = provider.findCandidateComponents("org/springframework");
        components.stream()
                .map(BeanDefinition::getBeanClassName)
                .sorted()
                .forEach(System.out::println);
    }
}